using e_suite.API.Common.models;
using e_suite.Utilities.Pagination;
using Microsoft.AspNetCore.Mvc;
using Moq;
using NUnit.Framework;

namespace eSuite.API.UnitTests.Controllers.SpecificationControllerUnitTests;

[TestFixture]
public class GetSpecificationsUnitTests : SpecificationControllerTestBase
{
    [SetUp]
    public override async Task Setup()
    {
        await base.Setup();
    }

    [Test]
    public async Task GetSpecifications_WhenCalled_ReturnsPagedData()
    {
        //Arrange
        var domains = new List<ReadSpecification>();

        var paginatedData = new PaginatedData<ReadSpecification>
        {
            Count = domains.Count,
            Data = domains,
            Page = 1,
            PageSize = 10
        };

        var cancellationToken = CancellationToken.None;

        var paging = new Paging();

        _specificationManagerMock.Setup(x => x.GetSpecifications(paging, cancellationToken)).ReturnsAsync(paginatedData);

        //Act
        var actualResult = await _specificationController.GetSpecifications(paging, cancellationToken);

        //Assert
        Assert.That(actualResult.GetType(), Is.EqualTo(typeof(OkObjectResult)));
        var objectResult = actualResult as OkObjectResult;

        Assert.That(objectResult?.StatusCode, Is.EqualTo(200));
        Assert.That(objectResult?.Value, Is.Not.Null);
        Assert.That(objectResult!.Value!.GetType, Is.EqualTo(typeof(PaginatedData<ReadSpecification>)));
    }
}